package jp.sf.amateras.javalib.mockrunner.filter;

import javax.servlet.Filter;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;

import com.mockrunner.mock.web.MockFilterConfig;
import com.mockrunner.servlet.BasicServletTestCaseAdapter;

public class EncodingFilterTest extends BasicServletTestCaseAdapter {

	private Filter filter;

	@Override
	public void setUp() throws Exception {
		super.setUp();
		filter = createFilter(EncodingFilter.class);
	}

	public void testFilter() throws ServletException {
		String encode = "UTF-8";

		// モックのFilterConfig生成
		MockFilterConfig config = getWebMockObjectFactory().getMockFilterConfig();
		// モックのFilterConfigに初期化パラメータを設定する
		config.setInitParameter("encode", encode);

		// init実行
		filter.init(config);
		// フィルタ実行
		doFilter();

		// エンコードが設定されたか確認
		ServletRequest request = getFilteredRequest();
		assertEquals(encode, request.getCharacterEncoding());
	}

}
